Attribute VB_Name = "M000003"
'-----------------------------------------------------------------------------'
'                           UNIVERSIDADE DE SO PAULO                         '
'                       ESCOLA DE ENGENHARIA DE SO CARLOS                    '
'                          DEPARTAMENTO DE TRANSPORTES                        '
'                            REA DE PS-GRADUAO                            '
'                                                                             '
'                        PROGRAMA EVALUATOR PARA WINDOWS                      '
'      INTERFACE PARA AVALIAO E ORDENAMENTO DE PROJETOS DE TRANSPORTE       '
'                     COM O USO DAS REDES NEURAIS ARTIFICIAIS                 '
'                                                                             '
'                      VERSO 1.00 - DESENVOLVIDA EM 01/01/98                 '
'                        POR: NILDER FURTADO/EIJI KAWAMOTO                    '
'-----------------------------------------------------------------------------'

'-----------------------------------------------------------------------------'
'                   MDULO 2 -  SERVIO DE APRENDIZAGEM/SIMULAO             '
'                                                                             '
' Este Mdulo Controla todas as atividades e rotinas do servio de aprendiza- '
' gem e Simulao: Executar o programa "N. Planner"(1); Gerar parties (2),  '
' Definir/consultar limites de normalizao(3); Gerar arquivos no formato     '
' "TTI" para leitura pelo simulador de Redes Neurais Artificiais (RNA)(4) e   '
' Verificar o desempenho de uma topologia investigada(5).                     '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'         01. DEFINIO DAS VARIVEIS GLOBAIS UTILIZADAS NESTE MDULO         '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
' Registro_Particionado = Define a formatao dos dados do arquivo de parti-  '
'                         es gerado "PAR".                                  '
'-----------------------------------------------------------------------------'
Public Type Registro_Particionado
    Cdigo_Projeto As String * 8
    Tipo_Partio As String * 3
    Status_da_Avaliao As String * 3
    Nmero_Aleatrio_Gerado As String * 8
End Type
'-----------------------------------------------------------------------------'
' Registro = Varivel utilizada para receber a leitura de cada um dos regis-  '
'            tros lido atravs de Registro_Particionado.                      '
'-----------------------------------------------------------------------------'
Dim Registro As Registro_Particionado
'-----------------------------------------------------------------------------'
' Seleo_Variveis = Array unidimensional onde fica registrado o cdigo de   '
'                     cada uma das variveis e o seu estado: presente/ausen-  '
'                     te.                                                     '
'-----------------------------------------------------------------------------'
Public Seleo_Variveis(240, 1)
'-----------------------------------------------------------------------------'
' St_Seleo_Todos = Controle que determina se todas as variveis sero uti-  '
'                    lizadas para gerar o arquivo "TTI". Caso este controle   '
'                    seja "false", nem todas as variveis foram selecionadas. '
'-----------------------------------------------------------------------------'
Public St_Seleo_Todos As Boolean
'-----------------------------------------------------------------------------'
' Contador = Define o Nmero de Variveis a serem includas no arquivo "TTI". '
'-----------------------------------------------------------------------------'
Public Contador As Integer
'-----------------------------------------------------------------------------'
' Contador_Aux = Acumula o valor do Contador para que o mesmo sirva de refe-  '
'                rncia para as parties de treinamento, validao ou teste. '
'-----------------------------------------------------------------------------'
Public Contador_Aux As Integer
'-----------------------------------------------------------------------------'
' Registros_Treinamento = Acumula a quantidade de casos que esto sendo con-  '
'                         siderados na partio de treinamento para controlar '
'                         os limites do padro de PRETCHELD.                  '
'-----------------------------------------------------------------------------'
Public Registros_Treinamento As Integer
'-----------------------------------------------------------------------------'
' Registros_Teste = Acumula a quantidade de casos que esto sendo considerados'
'                   na partio de teste para controlar os limites do padro  '
'                   de PRETCHELD.                                             '
'-----------------------------------------------------------------------------'
Public Registros_Teste As Integer
'-----------------------------------------------------------------------------'
' Registros_Validao = Acumula a quantidade de casos que esto sendo conside-'
'                       rados na partio de treinamento para controlar os li-'
'                       mites do padro de PRETCHELD.                         '
'-----------------------------------------------------------------------------'
Public Registros_Validao As Integer
'------------------------------------------------------------------------------'
' Registros_Treinamento_Aux = Acumula a quantidade de casos que esto sendo    '
'                         siderados na partio de treinamento para controlar  '
'                         os limites do padro de PRETCHELD.                   '
'------------------------------------------------------------------------------'
Public Registros_Treinamento_Aux As Integer
'------------------------------------------------------------------------------'
' Registros_Validao_Aux = Acumula a quantidade de casos que esto sendo      '
'                         siderados na partio de validao para controlar    '
'                         os limites do padro de PRETCHELD.                   '
'------------------------------------------------------------------------------'
Public Registros_Validao_Aux As Integer
'------------------------------------------------------------------------------'
' Registros_Teste_Aux = Acumula a quantidade de casos que esto sendo          '
'                         siderados na partio de teste para controlar        '
'                         os limites do padro de PRETCHELD.                   '
'------------------------------------------------------------------------------'
Public Registros_Teste_Aux As Integer
'------------------------------------------------------------------------------'
' Tipo_Partio_Aux = Acumula o tipo de partio para que este valor possa ser '
'                         usado em todos os casos de abertura/gravao de ar-  '
'                         quivos.                                              '
'------------------------------------------------------------------------------'
Public Tipo_Partio_Aux As String * 3
'------------------------------------------------------------------------------'
' Posio = Acumula um contador de tabulao para ser usado na formatao das  '
'           sees do arquivo "TTI"                                            '
'------------------------------------------------------------------------------'
Public Posio As Integer
'-----------------------------------------------------------------------------'
'                                  02. ROTINAS                                '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'     02.1. ROTINA DE CRIAO DO ARQUIVO DE NMEROS ALEATRIOS E PARTIES    '
'                           (Menu Principal: Mnu2_2)                          '
'                        Formulrio de Chamada : F201001                      '
'-----------------------------------------------------------------------------'
Sub Cria_Arquivo_Parties()
   
Open String_Pesquisa_1 For Output As #1
Open String_Pesquisa_2 For Output As #2

Abre_Tabela_F_01
Tabela_F_01.MoveFirst
Do Until Tabela_F_01.EOF
   Print #1, _
    Tab(1); Tabela_F_01!NUM_ALEATRIO; _
    Tab(11); Tabela_F_01!Cod_Projeto; _
    Tab(17); Tabela_F_01!st_aval
      
   Select Case Tipo_Padro
     Case 2
      If Tipo_Gerao_Partio = 1 Then
         If Tabela_F_01!st_aval = 1 Then
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #2, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!st_aval; _
                Tab(14); Tabela_F_01!NUM_ALEATRIO
                Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               If Registros_Validao_Aux < Registros_Validao Then
                  Print #2, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 2; _
                   Tab(11); Tabela_F_01!st_aval; _
                   Tab(14); Tabela_F_01!NUM_ALEATRIO;
                  Registros_Validao_Aux = Registros_Validao_Aux + 1
               Else
                  Print #2, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 3; _
                   Tab(11); Tabela_F_01!st_aval; _
                   Tab(14); Tabela_F_01!NUM_ALEATRIO
                  Registros_Teste_Aux = Registros_Teste_Aux + 1
               End If
            End If
         Else
            Print #2, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!st_aval; _
             Tab(14); Tabela_F_01!NUM_ALEATRIO;
            Registros_Teste_Aux = Registros_Teste_Aux + 1
         End If
      Else
      If Tabela_F_01!st_aval = 1 Then
            If Registros_Treinamento_Aux < Registros_Treinamento Then
               Print #2, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 1; _
                Tab(11); Tabela_F_01!st_aval; _
                Tab(14); Tabela_F_01!NUM_ALEATRIO;
               Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
            Else
               If Registros_Validao_Aux < Registros_Validao Then
                  Print #2, _
                   Tab(1); Tabela_F_01!Cod_Projeto; _
                   Tab(8); 2; _
                   Tab(11); Tabela_F_01!st_aval; _
                   Tab(14); Tabela_F_01!NUM_ALEATRIO;
                  Registros_Validao_Aux = Registros_Validao_Aux + 1
               Else
                 If Registros_Teste_Aux < Registros_Teste Then
                 Print #2, _
                  Tab(1); Tabela_F_01!Cod_Projeto; _
                  Tab(8); 3; _
                  Tab(11); Tabela_F_01!st_aval; _
                  Tab(14); Tabela_F_01!NUM_ALEATRIO;
                  Registros_Teste_Aux = Registros_Teste_Aux + 1
                  End If
                  
               End If
            End If
         Else
            Print #2, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 3; _
             Tab(11); Tabela_F_01!st_aval; _
             Tab(14); Tabela_F_01!NUM_ALEATRIO;
             Registros_Teste_Aux = Registros_Teste_Aux + 1
         End If
      End If
         
      Case 3
      If Tabela_F_01!st_aval = 1 Then
         If Registros_Treinamento_Aux < Registros_Treinamento Then
            Print #2, _
             Tab(1); Tabela_F_01!Cod_Projeto; _
             Tab(8); 1; _
             Tab(11); Tabela_F_01!st_aval; _
             Tab(14); Tabela_F_01!NUM_ALEATRIO
            Registros_Treinamento_Aux = Registros_Treinamento_Aux + 1
         Else
            If Registros_Validao_Aux < Registros_Validao Then
               Print #2, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 2; _
                Tab(11); Tabela_F_01!st_aval; _
                Tab(14); Tabela_F_01!NUM_ALEATRIO;
               Registros_Validao_Aux = Registros_Validao_Aux + 1
            Else
               Print #2, _
                Tab(1); Tabela_F_01!Cod_Projeto; _
                Tab(8); 3; _
                Tab(11); Tabela_F_01!st_aval; _
                Tab(14); Tabela_F_01!NUM_ALEATRIO;
               Registros_Teste_Aux = Registros_Teste_Aux + 1
            End If
         End If
       Else
          Print #2, _
           Tab(1); Tabela_F_01!Cod_Projeto; _
           Tab(8); 3; _
           Tab(11); Tabela_F_01!st_aval; _
           Tab(14); Tabela_F_01!NUM_ALEATRIO;
          Registros_Teste_Aux = Registros_Teste_Aux + 1
       End If
    End Select
    
    Tabela_F_01.MoveNext
    
   Loop
   
   If Registros_Treinamento_Aux = 0 Then
          MsgBox "NO FOI POSSVEL A", 48, "CONCLUSO"
          End If

Tabela_F_01.Close
Print #1, Tab(2); "99999999"; Tab(11); "99999"; Tab(17); "9"
Print #2, Tab(1); 99999; Tab(8); 9; Tab(11); 9; Tab(14); 99999999
Close #1
Close #2

MsgBox "terminei", 48, "concluso"
Unload F201001

End Sub



'-----------------------------------------------------------------------------'
'                  02.2. ROTINAS DE CRIAO DO ARQUIVO "TTI"                  '
' O arquivo "TTI" a ser utilizado pelo Neural Planner  composto das seguntes '
' sees: [LABELS], que identifica as variveis de entrada/sada; [TRAINING]  '
' onde ficam descritos os projetos/alternativas considerados na partio de   '
' treinamento; [TESTING] onde ficam descritos os projetos/alternativas consi- '
' derados na partio de validao, [INTERROGATING](2)onde ficam descritos os '
' projetos/alternativas escolhidos para o teste e a seo [LIMITS] onde ficam '
' descritos os valores mximos e mnimos considerados na normalizao de cada '
' uma das variveis selecionadas.                                             '
' (2) O Neural Planner no utiliza a definio padro de PRETCHELD que estabe-'
'     lece parties de "TREINAMENTO", "VALIDAO" e "TESTE"                  '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'                  02.2.a. FORMATAO DO CABEALHO  GERAL DO ARQUIVO          '
'-----------------------------------------------------------------------------'
Sub Cria_Cabealho_Tti()
    Print #1, String(1021, "-")
    Print #1, _
     "     EVALUATOR                                                        "
    Print #1, _
     "     ARQUIVO DE SIMULACAO DE REDES NEURAIS ARTIFICIAIS                "
    Print #1, _
     "     Desenvolvido por: Nilder Furtado/Eiji Kawamoto                   "
    Print #1, _
     "     Data/Horario da Criacao/Atualizacao:"; Date; Time
    Print #1,
    If Tipo_Servio = 2 Then
       Print #1, _
         "     ESTE ARQUIVO FOI GERADO COM INDICE DE PRIORIDADE DE";
       Print #1, "Alternativa E"
       Print #1, _
         "     DEVE SER USADO PARA SIMULACAO/APRENDIZAGEM EM REDES";
       Print #1, " COM 1 SAIDA"
    Else
       Print #1, _
         "     ESTE ARQUIVO FOI GERADO COM INDICE DE ORDENAMENTO DE";
       Print #1, " ALTERNATIVAS E"
       Print #1, _
         "     DEVE SER USADO PARA SIMULAO/APRENDIZAGEM EM REDES COM";
       Print #1, " 12 SAIDAS"
    End If
    Print #1, String(1021, "-")
    Print #1, ""
End Sub
'-----------------------------------------------------------------------------'
'             02.2.b. DEFINIO DO ARQUIVO DE PARTIES A SER ABERTO          '
'-----------------------------------------------------------------------------'
Sub Define_Arquivo_Parties()
  F000002.Caption = "Aprendizagem/Simulao - IPA - Parties"
  F000002.Mscara_1.AddItem "*.par (NPlanner)"
End Sub

'-----------------------------------------------------------------------------'
'                         02.2.c. GRAVAO DA SEO 1 - "LABELS"              '
'-----------------------------------------------------------------------------'
Sub Grava_Labels_Tti()
    Dim Contador_Variveis As Variant
    Dim Nmero As String
    Dim I%
    
    
    Open String_Pesquisa_1 For Append As #1
    Print #1, String(1021, "-")
    Print #1, _
         "     DESCRICAO DAS SECOES DE IDENTIFICACAO DAS VARIAVEIS";
    Print #1, " DE ENTRADA/SAIDA"
    Print #1, _
         "     E SECOES DE TREINAMENTO, VALIDACAO, TESTE E NORMALIZACAO"
    Print #1, String(1021, "-")
    Print #1, "[LABELS]"
    If St_Seleo_Todos = True Then
       Contador_Variveis = 1
       Do Until Contador_Variveis > 240
          Nmero = Contador_Variveis
          If Contador_Variveis < 10 Then
             Print #1, "  [V-00"; Nmero; "]"
          Else
             If Contador_Variveis < 100 Then
                Print #1, "  [V-0"; Nmero; "]"
             Else
                Print #1, "  [V-"; Nmero; "]"
             End If
          End If
          Contador_Variveis = Contador_Variveis + 1
          Loop
    Else
        For I = 1 To 240
        Nmero = I%
        If Seleo_Variveis(I%, 1) = True Then
           If Nmero < 10 Then
              Print #1, "  [V-00"; Nmero; "]"
           Else
              If Nmero < 100 Then
                 Print #1, "  [V-0"; Nmero; "]"
              Else
                 Print #1, "  [V-"; Nmero; "]"
              End If
           End If
        End If
        Next
        
    End If
    
    Print #1, ""
    
    If Tipo_Servio = 2 Then
       Print #1, "  [IPA]"
    Else
       Print #1, "  [IOA-01]"
       Print #1, "  [IOA-02]"
       Print #1, "  [IOA-03]"
       Print #1, "  [IOA-04]"
       Print #1, "  [IOA-05]"
       Print #1, "  [IOA-06]"
       Print #1, "  [IOA-07]"
       Print #1, "  [IOA-08]"
       Print #1, "  [IOA-09]"
       Print #1, "  [IOA-10]"
       Print #1, "  [IOA-11]"
       Print #1, "  [IOA-12]"
    End If
    Print #1, "[END]"
    Print #1, ""
    
    
End Sub
'-----------------------------------------------------------------------------'
'   02.2.d. GRAVAO DE CABEALHOS DAS SECOES 2, 3, 4 E 5 - TREINAMENTO,      '
'                              VALIDAO E TESTE                              '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'     02.2.d.1. FORMATAO DO CABEALHO DOS DADOS DE TREINAMENTO [TRAINING]   '
'-----------------------------------------------------------------------------'
Sub Grava_Treinamento_Tti()
    If St_Seleo_Todos = True Then
       Print #1, "[TRAINING]   "; String(240, ">");
    Else
       If Contador_Aux > 14 Then
          Print #1, "[TRAINING]   "; String(14, ">");
          Contador_Aux = Contador_Aux - 14
          Complementa_Entradas_tti
       Else
          Print #1, "[TRAINING]   "; String(Contador_Aux, ">");
       End If
    End If
    
    If Tipo_Servio = 2 Then
       Print #1, "<"
    Else
       Print #1, String(12, "<")
    End If
End Sub
'-----------------------------------------------------------------------------'
'     02.2.d.2. FORMATAO DO CABEALHO DOS DADOS DE VALIDAO [TRAINING]     '
'-----------------------------------------------------------------------------'
Sub Grava_Validao_Tti()
    If St_Seleo_Todos = True Then
       Print #1, "[TESTING ]   "; String(240, ">");
    Else
       If Contador_Aux > 14 Then
          Print #1, "[TESTING]    "; String(14, ">");
          Contador_Aux = Contador_Aux - 14
          Complementa_Entradas_tti
       Else
          Print #1, "[TESTING]    "; String(Contador_Aux, ">");
       End If
    End If
     
    If Tipo_Servio = 2 Then
          Print #1, "<"
       Else
          Print #1, String(12, "<")
       End If
End Sub
'-----------------------------------------------------------------------------'
'     02.2.d.3. FORMATAO DO CABEALHO DOS DADOS DE TESTE [INTERROGATING]    '
'-----------------------------------------------------------------------------'
Sub Grava_Teste_Tti()
    If St_Seleo_Todos = True Then
       Print #1, "[INTERROGATING]"; String(240, ">");
    Else
       If Contador_Aux > 14 Then
          Print #1, "[INTERROGATING]"; String(14, ">");
          Contador_Aux = Contador_Aux - 14
          Complementa_Entradas_tti
       Else
       Print #1, "[INTERROGATING]"; String(Contador_Aux, ">");
       End If
    End If
     
    If Tipo_Servio = 2 Then
          Print #1, "<"
       Else
          Print #1, String(12, "<")
       End If
End Sub

'-------------------------------------------------------------------------------'
'   02.2.d.4. FORMATAO DE CABEALHO DE DADOS (TREINAMENTO/VALIDAO/TESTE)    '
'                 SELEO PARCIAL DE VARIVEIS DE AVALIAO/DECISO             '
'-------------------------------------------------------------------------------'
Sub Complementa_Entradas_tti()
    
    If Contador_Aux > 14 Then
       Print #1, String(14, ">");
       Contador_Aux = Contador_Aux - 14
    Else
       If Contador_Aux > 14 Then
          Print #1, String(14, ">");
          Contador_Aux = Contador_Aux - 14
       Else
          If Contador_Aux > 14 Then
             Print #1, String(14, ">");
             Contador_Aux = Contador_Aux - 14
          Else
             If Contador_Aux > 14 Then
                Print #1, String(14, ">");
                Contador_Aux = Contador_Aux - 14
             Else
                If Contador_Aux > 14 Then
                   Print #1, String(14, ">");
                   Contador_Aux = Contador_Aux - 14
                Else
                   Print #1, String(Contador_Aux, ">");
                End If
             End If
          End If
       End If
    End If
End Sub
'-----------------------------------------------------------------------------'
'   02.2.e. GRAVAO DE DADOS DAS SECOES 2, 3, 4 E 5 - TREINAMENTO/VALIDAO  '
'                               TESTE E NORMALIZAO                          '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'               02.2.e.1. GRAVAO DOS DADOS DE TREINAMENTO [TRAINING]        '
'-----------------------------------------------------------------------------'
Sub Grava_Registros_Treinamento_Tti()
 Consulta_Projeto.MoveFirst
 Consulta_Alternativa.MoveFirst
 Open String_Pesquisa_2 For Random As #3 Len = Len(Registro)
 Abre_Tabela_C_01_Aux
 Get #3, , Registro
 Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio
 Do While Cod_Projeto_Aux <> 99999
    If Tipo_Partio_Aux = 1 Then
       Tabela_C_01_Aux.Seek "=", Cod_Projeto_Aux
          Busca_Registro_Consulta
          Do While Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
             Grava_Dados_Registro_Tti
             Grava_Dados_Sada_Tti
             Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
             Tabela_C_01_Aux.MoveNext
             Consulta_Alternativa.MoveNext
          Loop
       End If
    Tabela_C_01_Aux.MoveFirst
    Get #3, , Registro
    Cod_Projeto_Aux = Registro.Cdigo_Projeto
    Tipo_Partio_Aux = Registro.Tipo_Partio
 Loop
 Print #1, "[END]"
 Print #1, ""
 Tabela_C_01_Aux.Close
 Close #3
End Sub
'-----------------------------------------------------------------------------'
'                02.2.e.2. GRAVAO DOS DADOS DE VALIDAO [TESTING]          '
'-----------------------------------------------------------------------------'
Sub Grava_Registros_Validao_Tti()
 Open String_Pesquisa_2 For Random As #3 Len = Len(Registro)
 Abre_Tabela_C_01_Aux
 Get #3, , Registro
 Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio
 Do While Cod_Projeto_Aux <> 99999
    If Tipo_Partio_Aux = 2 Then
       Tabela_C_01_Aux.Seek "=", Cod_Projeto_Aux
       Busca_Registro_Consulta
       Do While Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
          Grava_Dados_Registro_Tti
          Grava_Dados_Sada_Tti
          Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
          Tabela_C_01_Aux.MoveNext
          Consulta_Alternativa.MoveNext
       Loop
    End If
    Tabela_C_01_Aux.MoveFirst
    Get #3, , Registro
    Cod_Projeto_Aux = Registro.Cdigo_Projeto
    Tipo_Partio_Aux = Registro.Tipo_Partio
 Loop
 
 Print #1, "[END]"
 Print #1, ""
 Tabela_C_01_Aux.Close
Close #3
End Sub
'-----------------------------------------------------------------------------'
'                 02.2.e.3. GRAVACAO DOS DADOS DE TESTE [INTERROGATING]       '
'-----------------------------------------------------------------------------'
Sub Grava_Registros_Teste_Tti()
 Open String_Pesquisa_2 For Random As #3 Len = Len(Registro)
 Abre_Tabela_C_01_Aux
 Get #3, , Registro
 Cod_Projeto_Aux = Registro.Cdigo_Projeto
 Tipo_Partio_Aux = Registro.Tipo_Partio

 Do While Cod_Projeto_Aux <> 99999
    If Tipo_Partio_Aux = 3 Then
       Tabela_C_01_Aux.Seek "=", Cod_Projeto_Aux
       Busca_Registro_Consulta
       Do While Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
          Grava_Dados_Registro_Tti
          Grava_Dados_Sada_Tti
          Cod_Projeto_Aux = Tabela_C_01_Aux!Cod_Projeto
          Tabela_C_01_Aux.MoveNext
          Consulta_Alternativa.MoveNext
       Loop
          Consulta_Projeto.MoveFirst
    End If
    Tabela_C_01_Aux.MoveFirst
    Get #3, , Registro
    Cod_Projeto_Aux = Registro.Cdigo_Projeto
    Tipo_Partio_Aux = Registro.Tipo_Partio
 Loop
 Debug.Print "st_achou_partio_teste"; St_Achou_Partio
 Print #1, "[END]"
 Print #1, ""
 Tabela_C_01_Aux.Close
 Close #3
End Sub
'-----------------------------------------------------------------------------'
'              02.2.f. CONSULTA DE CDIGOS PROJETO/ALTERNATIVAS               '
'-----------------------------------------------------------------------------'
Sub Busca_Registro_Consulta()
Consulta_Projeto.MoveFirst
Consulta_Alternativa.MoveFirst
Do Until Consulta_Projeto.EOF Or Cod_Projeto_Aux = Consulta_Projeto!Cod_Projeto
       Consulta_Projeto.MoveNext
    Loop
       
    Do Until Cod_Projeto_Aux = Consulta_Alternativa!Cod_Projeto _
       Or Consulta_Alternativa.EOF
       Consulta_Alternativa.MoveNext
    Loop
End Sub
'-----------------------------------------------------------------------------'
'   02.2.g. GRAVAO DOS REGISTROS DAS SECOES DE TREINAMENTO/VALIDAO/TESTE  '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'                02.2.g.1. FORMATAO DO CABEALHO DOS REGISTROS              '
'-----------------------------------------------------------------------------'
Sub Formata_Entrada_Registro_Tti()
 Dim Projeto As Variant
 Dim Alternativa As Variant
 Dim Projeto_Aux As String
 Dim Alternativa_Aux As String
 
 Projeto = Tabela_C_01_Aux!Cod_Projeto
 Alternativa = Tabela_C_01_Aux!Cod_Alternativa
 Projeto_Aux = Projeto
 Alternativa_Aux = Alternativa
          
 If Projeto < 10 Then
    Print #1, Tab(0); " [P-00"; Projeto_Aux;
    
 Else
    If Projeto < 100 Then
       Print #1, " [P-0"; Projeto;
    Else
       Print #1, " [P-"; Projeto; "-"; Alternativa; "]";
    End If
 End If
 
 If Alternativa < 10 Then
    Print #1, "-0"; Alternativa_Aux; "]";
 Else
    Print #1, Alternativa_Aux; "]";
 End If
 
 
End Sub

















'-----------------------------------------------------------------------------'
'     02.2.g.2. GRAVAO DOS REGISTROS DE ENTRADA DOS PROJETOS/ALTERNATIVAS   '
'-----------------------------------------------------------------------------'
Sub Grava_Dados_Registro_Tti()
 Dim Nmero_Varivel As Integer
 Dim Contador_Alternativas As Integer
 Posio = 6
 If St_Seleo_Todos = True Then
    Formata_Entrada_Registro_Tti
    Contador_Alternativas = Contador_Alternativas + 1
    For Nmero_Varivel = 1 To 105
        Select Case VarType(Consulta_Projeto(Nmero_Varivel))
         Case 1
         Posio = Posio + 8
           Print #1, Tab(Posio); " ?";
         Case 2, 6
         Posio = Posio + 8
           Print #1, Tab(Posio); Consulta_Projeto(Nmero_Varivel);
         Case 11
         Posio = Posio + 8
          If Consulta_Projeto(Nmero_Varivel) = True Then
              Print #1, Tab(Posio); 1;
          Else
              Print #1, Tab(Posio); 0;
          End If
         End Select
     Next
     
     For Nmero_Varivel = 2 To 136
         
        Select Case VarType(Consulta_Alternativa(Nmero_Varivel))
         Case 1
          Posio = Posio + 8
          Print #1, Tab(Posio); " ?";
         Case 2, 6
          Posio = Posio + 8
          Print #1, Tab(Posio); Consulta_Alternativa(Nmero_Varivel);
         Case 11
          Posio = Posio + 8
          If Consulta_Alternativa(Nmero_Varivel) = True Then
           Print #1, Tab(Posio); 1;
          Else
           Print #1, Tab(Posio); 0;
          End If
         End Select
     Next
 Else
    Formata_Entrada_Registro_Tti
    Contador_Alternativas = Contador_Alternativas + 1
    For Nmero_Varivel = 1 To 240
        If Seleo_Variveis(Nmero_Varivel, 1) = True Then
           If Nmero_Varivel < 106 Then
              Select Case VarType(Consulta_Projeto(Nmero_Varivel))
               Case 1
                Posio = Posio + 8
                Print #1, Tab(Posio); " ?"
               Case 2, 6
                Posio = Posio + 8
                Print #1, Tab(Posio); Consulta_Projeto(Nmero_Varivel);
               Case 11
               Posio = Posio + 8
                If Consulta_Projeto(Nmero_Varivel) = True Then
                   Print #1, Tab(Posio); 1;
                Else
                  Print #1, Tab(Posio); 0;
               End If
              End Select
           
           Else
              Select Case VarType(Consulta_Alternativa(Nmero_Varivel - 104))
               Case 1
               Posio = Posio + 8
                Print #1, Tab(Posio); " ?";
               Case 2, 6
                Posio = Posio + 8
                Print #1, Tab(Posio); Consulta_Alternativa(Nmero_Varivel - 104);
               Case 11
                Posio = Posio + 8
                If Consulta_Alternativa(Nmero_Varivel - 104) = True Then
                   Print #1, Tab(Posio); 1;
                Else
                   Print #1, Tab(Posio); 0;
                End If
               End Select
           End If
        End If
    Next
 End If
End Sub
'-----------------------------------------------------------------------------'
'      02.2.g.3. GRAVAO DOS REGISTROS DE SAIDA DOS PROJETOS/ALTERNATIVAS    '
'-----------------------------------------------------------------------------'
Sub Grava_Dados_Sada_Tti()
 Dim I%
 Dim Prioridade As Integer
 Prioridade = Tabela_C_01_Aux!IND_PRIORIDADE
 
 If Tipo_Partio_Aux = 1 Or Tipo_Partio_Aux = 2 Then
    If Tipo_Servio = 2 Then
       For I = 1 To 12
            If I% = Prioridade Then
               Posio = Posio + 8
               Print #1, Tab(Posio); Prioridade
            End If
       Next
    Else
       Select Case Prioridade
        Case 1
         Print #1, 1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0
        Case 2
         Print #1, 0; 1; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0
        Case 3
         Print #1, 0; 0; 1; 0; 0; 0; 0; 0; 0; 0; 0; 0
        Case 4
         Print #1, 0; 0; 0; 1; 0; 0; 0; 0; 0; 0; 0; 0
        Case 5
         Print #1, 0; 0; 0; 0; 1; 0; 0; 0; 0; 0; 0; 0
        Case 6
         Print #1, 0; 0; 0; 0; 0; 1; 0; 0; 0; 0; 0; 0
        Case 7
         Print #1, 0; 0; 0; 0; 0; 0; 1; 0; 0; 0; 0; 0
        Case 8
         Print #1, 0; 0; 0; 0; 0; 0; 0; 1; 0; 0; 0; 0
        Case 9
         Print #1, 0; 0; 0; 0; 0; 0; 0; 0; 1; 0; 0; 0
        Case 10
         Print #1, 0; 0; 0; 0; 0; 0; 0; 0; 0; 1; 0; 0
        Case 11
         Print #1, 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1; 0
        Case 12
         Print #1, 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 1
        End Select
    End If
  Else
    If Tipo_Servio = 2 Then
       Posio = Posio + 8
       Print #1, Tab(Posio); " ?"
    Else
        Print #1, "?"; "?"; "?"; "?"; "?"; "?"; "?"; "?"; "?"; "?"; "?"; "?"
    End If
  End If
End Sub



'-----------------------------------------------------------------------------'
'      02.2.h. GRAVAO DE DADOS DAS SECAO 5 - LIMITES DE NORMALIZAO        '
'-----------------------------------------------------------------------------'
'-----------------------------------------------------------------------------'
'              02.2.h.1. GRAVAO DOS DADOS PARA TODAS AS VARIVEIS           '
'-----------------------------------------------------------------------------'
Sub Grava_Todos_Limites_Normalizao_Tti()
 Abre_Tabela_D_01
    Print #1, "[LIMITS ]    "; String(240, ">");
    If Tipo_Servio = 2 Then
       Print #1, "<"
    Else
       Print #1, String(12, "<")
    End If
    Print #1, " [HIGHS]";
    Posio = 6
    Do Until Tabela_D_01.EOF
       Posio = Posio + 8
       Print #1, Tab(Posio); Tabela_D_01!LIM_MXIMO;
       Tabela_D_01.MoveNext
    Loop
    If Tipo_Servio = 2 Then
     Posio = Posio + 8
     Print #1, Tab(Posio); 12
    Else
     Print #1, 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1
    End If
    Print #1, " [LOWS]";
    Posio = 6
    Tabela_D_01.MoveFirst
    Do Until Tabela_D_01.EOF
       Posio = Posio + 8
       Print #1, Tab(Posio); Tabela_D_01!LIM_MNIMO;
       Tabela_D_01.MoveNext
    Loop
  
  
  If Tipo_Servio = 2 Then
     Posio = Posio + 8
     Print #1, Tab(Posio); 1
  Else
     Print #1, 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0
  End If
  Print #1, "[END]"
  Print #1, String(1021, "-")
  Print #1, _
         "                             FIM DO ARQUIVO                         "
  Print #1, _
         "               FORAM USADAS TODAS AS VARIAVEIS DE ENTRADA/SAIDA"

  Print #1, String(1021, "-")
End Sub
'-----------------------------------------------------------------------------'
'              02.2.h.2. GRAVAO DOS DADOS PARA ALGUMAS VARIVEIS            '
'-----------------------------------------------------------------------------'
Sub Grava_Alguns_Limites_Normalizao_Tti()
  Dim I%
  If Contador_Aux > 14 Then
     Print #1, "[LIMITS]     "; String(14, ">");
     Contador_Aux = Contador_Aux - 14
     Complementa_Entradas_tti
  Else
    Print #1, "[LIMITS]     "; String(Contador_Aux, ">");
  End If
    
  If Tipo_Servio = 2 Then
     Print #1, "<"
  Else
     Print #1, String(12, "<")
  End If
  Print #1, " [HIGHS]";
  Posio = 6
  For I = 1 To 240
      If Seleo_Variveis(I%, 1) = True Then
         Posio = Posio + 8
         Tabela_D_01.Seek "=", I%
         Print #1, Tab(Posio); Tabela_D_01!LIM_MXIMO;
      End If
  Next
    
  If Tipo_Servio = 2 Then
     Posio = Posio + 8
     Print #1, Tab(Posio); 12
  Else
     Print #1, 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1
  End If
  
  Print #1, " [LOWS]";
  Posio = 6
  For I = 1 To 240
      If Seleo_Variveis(I%, 1) = True Then
          Posio = Posio + 8
         Tabela_D_01.Seek "=", I%
         Print #1, Tab(Posio); Tabela_D_01!LIM_MNIMO;
      End If
  Next
    
  If Tipo_Servio = 2 Then
     Posio = Posio + 8
     Print #1, Tab(Posio); 1
  Else
     Print #1, 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0; 0
  End If
  Print #1, "[END]"
  Print #1, String(1021, "-")
  Print #1, _
         "                             FIM DO ARQUIVO"
  Print #1, _
         "               FORAM USADAS " & Contador & "  VARIAVEIS DE ENTRADA"
  Print #1, String(1021, "-")
End Sub
'-----------------------------------------------------------------------------'
'                                FIM DO MDULO 2                              '
'-----------------------------------------------------------------------------'





      






    



















